#ifndef LIVEKIT_BCLREPRESENTATION_H
#define LIVEKIT_BCLREPRESENTATION_H

#include <map>
#include <vector>
#include <deque>
#include <functional>
#include <mutex>

/**
 * Container for all bases and qualities from a single tile and a single cycle
 */
typedef std::vector<char> BCL;

/**
 * Container for multiple `BCL`.
 * The data is structured after lane, tile, cycle.
 */
typedef std::map<uint16_t, std::map<uint16_t, std::map<uint16_t, BCL>>> BCLDATA;

/**
 * The BclRepresentation holds all parsed `BCL`s and exposes a public interface for interaction.
 */
class BclRepresentation {
private:

    std::mutex serializationMutex;

    /**
     * Stores the parsed BCL data for each tile.
     * usage: bclData[lane][tile][cycle]
     */
    BCLDATA bclData;

    /**
     * BCL can be serialized to save memory. The BCLs are serialized lazy when needed.
     * This map keeps track about which BCLs are serialized
     */
    std::map<uint16_t, std::map<uint16_t, std::map<uint16_t, bool>>> isBclSerialzied;

    friend class BaseManager;

public:
    /**
     * Creates a BclRepresentation and initializes the bclData which stores the actual BCLs
     * @param lanes
     * @param tiles
     */
    BclRepresentation(std::vector<uint16_t> &lanes, std::vector<uint16_t> &tiles);

    /**
     * @param lane
     * @param tile
     * @return the number of parsed nucletides for the specified lane
     */
    uint32_t getBclSize(uint16_t lane, uint16_t tile);

    /**
     * Get BCL of all reads of a specific cycle
     * @param lane
     * @param tile
     * @param cycle
     * @return the BCL as a vector<char>
     */
    const BCL &getBcl(uint16_t lane, uint16_t tile, uint16_t cycle);

    /**
     * Adds the newBcl into bclData.
     * @param lane
     * @param tile
     * @param cycle
     * @param newBcl
     */
    void addBcl(uint16_t lane, uint16_t tile, uint16_t cycle, BCL& newBcl);

    /**
     * Returns if the specified BCL is currently serialized.
     * @param lane
     * @param tile
     * @param cycle
     * @return
     */
    bool  isSerialized(uint16_t lane, uint16_t tile, uint16_t cycle);

    /**
     * Serializes the specified BCL to save memory.
     * We can simply delete the BCL from bclData without writing its content to the disk first, because the BCL is
     * already stored on the disk (generated by the sequencer).
     * @param lane
     * @param tile
     * @param cycle
     */
    void serialize(uint16_t lane, uint16_t tile, uint16_t cycle);
};


#endif //LIVEKIT_BCLREPRESENTATION_H
